Day16(贪心算法)——LeetCode45.跳跃游戏II&763.划分字母区间

1 LeetCode45.跳跃游戏II

1.1 题目描述

  与跳跃游戏类似,跳跃游戏II给定长为n的从0开始索引的整数数组nums,nums[i]是你在i处能向右跳跃的最大步数,求到达数组最后一个索引处需要跳跃的最少次数。

  一个示例:nums[2,3,1,1,4],则到达下标4的位置需要跳至少两次,即从下标0跳到下标1,再从下标1跳到下标4。

1.2 问题分析及解决

  贪心的思想,即在当前位置所能跳跃的范围内,选择跳跃到有最大跳跃长度的位置。例如nums=[2,3,1,1,4],从下标0可以跳跃到下标1、下标2,但下标1最大跳跃长度为3,比下标2的最大跳跃长度大,因此我们选择跳跃到下标1。

  像上面的思路我们貌似需要每一次遍历数组的一小部分决定下一步要走到哪,这样的话时间复杂度为 O ( n 2 ) O(n^2) O(n2)。可以换个角度,但本质上与上述思路相同。

  我们从一个位置跳跃到其能跳远的最远长度所在的下标now_right的过程中,记录下这之间的所有位置能达到的最远位置的下标max_right,若我们到达了now_right,但仍没到最后一个下标,此时步数就得+1。因为相当于我们回头从具有最大跳跃长度的位置开始跳(步数+1),而回头不需要步数。

  仍以上述为例,nums=[2,3,1,1,4],我们从nums[0]开始跳,其最远可以到达nums[0]+0=2(now_right=2),并记录下在其跳跃范围内的位置能到达的最远下标nums[1]+1=4(max_right=4)。当我们跳到下标2时,我们无法从nums[0]开始再往右跳,因此需要步数+1,从nums[1]起跳,由于我们记录了从nums[1]起跳最远能到达下标4,因此我们只需更新now_right=max_right即可,然后继续上述操作。注意我们只需要判断最远距离能否到达倒数第2个下标,因为若能从某个位置直接到最后一个下标,这不算步数,因此只需判断能否到达倒数第二个下标,若能则肯定也能到最后一个下标;若不能则步数+1就能到达最后一个下标了。

  具体实现如下:

cpp 复制代码
class Solution {
public:
    int jump(vector<int>& nums) {
        int ans=0;
        //记录跳跃过程中能到达的最大下标
        int maxright=0;
        //记录从当前位置跳跃能到达的最大下标
        int nowright=0;
        for(int i=0;i<nums.size()-1;i++){
            maxright=max(maxright,nums[i]+i);
            //如果此时还没到最后一个下标
            if(i==nowright){
                //步数+1,从而才能继续向前
                nowright=maxright;
                ans++;
            }
        }
        return ans;
    }
};

2 LeetCode763.划分字母区间

2.1 题目描述

  给定一个字符串s,将字符串划分为尽可能多的片段,同一字母最多出现在一个片段中。如s="ababcc",则最终的划分结果为["abab","cc"]。返回表示每个字符串片段的长度的列表。

  一个示例如下:

2.2 问题分析及解决

  贪心的思想,从第一个字母开始遍历,定义指针left指向划分的最左边,right指向划分的最右边,因此right要更新为遍历字母中最后出现的位置的最大值,直到遍历位置与right相等,说明left和right之间就是一个划分。更新left=right+1,继续上述操作即可。

  具体实现如下:

cpp 复制代码
class Solution {
public:
    vector<int> partitionLabels(string s) {
        vector<int> ans;
        int end_char[26];
        //记录每个字母最后出现的位置
        for(int i=0;i<s.length();i++){
            end_char[s[i]-'a']=i;
        }
        //记录遍历过程中每个字母最后一次出现的位置
        int right=0;
        //划分的左边
        int left=0;
        //划分的右边
        int partition=-1;
        for(int i=0;i<s.length();i++){
            right=end_char[s[i]-'a'];
            //划分右边为遍历字母最后一次出现位置的最大值
            partition=max(partition,right);
            //如果遍历到划分位置,则说明是一个划分
            if(i==partition){
                ans.push_back(partition-left+1);
                left=right+1;
            }
        }
        return ans;
    }
};
相关推荐
Fuyo_111920 分钟前
C++ 运行时多态与虚函数机制全面剖析【面试重点】
开发语言·c++·面试
w_zero_one1 小时前
递归算法(一)
java·开发语言·算法
圣保罗的大教堂1 小时前
leetcode 3736. 最小操作次数使数组元素相等 III 简单
leetcode
文丑颜不良啊2 小时前
LeetCode1881~1990题目解析
java·leetcode
Chen_harmony2 小时前
七、STL与string类
开发语言·c++
xxxiugou1232 小时前
C++命名空间与引用全解析
开发语言·c++
风影同志783243 小时前
20 个比特能装下多少行情?——实测拆解 Kronos 的 K 线分词器
算法
写的都是BUG3 小时前
APK 里的钥匙,一直就放在门口:聊聊加固真正该做什么
前端·算法
用户7624117567053 小时前
第十五章 人工智能基础
c++
地平线开发者4 小时前
CLIP 的零样本分类:一组文本如何变成图像分类器?
算法